hdu 1688 Sightseeing(最短路+次短路条数)

Sightseeing

Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 969    Accepted Submission(s): 409


Problem Description
Tour operator Your Personal Holiday organises guided bus trips across the Benelux. Every day the bus moves from one city S to another city F. On this way, the tourists in the bus can see the sights alongside the route travelled. Moreover, the bus makes a number of stops (zero or more) at some beautiful cities, where the tourists get out to see the local sights.

Different groups of tourists may have different preferences for the sights they want to see, and thus for the route to be taken from S to F. Therefore, Your Personal Holiday wants to offer its clients a choice from many different routes. As hotels have been booked in advance, the starting city S and the final city F, though, are fixed. Two routes from S to F are considered different if there is at least one road from a city A to a city B which is part of one route, but not of the other route.

There is a restriction on the routes that the tourists may choose from. To leave enough time for the sightseeing at the stops (and to avoid using too much fuel), the bus has to take a short route from S to F. It has to be either a route with minimal distance, or a route which is one distance unit longer than the minimal distance. Indeed, by allowing routes that are one distance unit longer, the tourists may have more choice than by restricting them to exactly the minimal routes. This enhances the impression of a personal holiday.



For example, for the above road map, there are two minimal routes from S = 1 to F = 5: 1 → 2 → 5 and 1 → 3 → 5, both of length 6. There is one route that is one distance unit longer: 1 → 3 → 4 → 5, of length 7.

Now, given a (partial) road map of the Benelux and two cities S and F, tour operator Your Personal Holiday likes to know how many different routes it can offer to its clients, under the above restriction on the route length.

 

Input
The first line of the input file contains a single number: the number of test cases to follow. Each test case has the following format:

One line with two integers N and M, separated by a single space, with 2 ≤ N ≤ 1,000 and 1 ≤ M ≤ 10, 000: the number of cities and the number of roads in the road map.

M lines, each with three integers A, B and L, separated by single spaces, with 1 ≤ A, B ≤ N, A ≠ B and 1 ≤ L ≤ 1,000, describing a road from city A to city B with length L.

The roads are unidirectional. Hence, if there is a road from A to B, then there is not necessarily also a road from B to A. There may be different roads from a city A to a city B.

One line with two integers S and F, separated by a single space, with 1 ≤ S, F ≤ N and S ≠ F: the starting city and the final city of the route.

There will be at least one route from S to F.

 

Output
For every test case in the input file, the output should contain a single number, on a single line: the number of routes of minimal length or one distance unit longer. Test cases are such, that this number is at most 10^9 = 1,000,000,000.

 

Sample Input
  
  
2 5 8 1 2 3 1 3 2 1 4 5 2 3 1 2 5 3 3 4 2 3 5 4 4 5 3 1 5 5 6 2 3 1 3 2 1 3 1 10 4 5 2 5 2 7 5 2 7 4 1
 

Sample Output
  
  
3 2
题意:T组测试样例,n个点m条单向边,然后求s到e的最短路径数,如果次短路经=最短路径+1,那么加上次短路经数

思路:用迪杰斯特拉可以求得最短路径和次短路经的长度及 数目。 d数组是路径长度,dp数组是路径条数。0表示最短,1表示次短。具体看代码吧。

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
#define N 1010
#define M 10010
#define INF 1<<30
struct Edge
{
    int v,next,w;
}edge[M];
int n,m;
int vis[N][2];
int d[N][2],dp[N][2];
int head[N],cnt;
void init()
{
   cnt=0;
   memset(head,-1,sizeof(head));
}
void addedge(int u,int v,int w)
{
    edge[cnt].v=v;
    edge[cnt].w=w;
    edge[cnt].next=head[u];
    head[u]=cnt++;
}
void djstl(int s,int e)
{
    for(int i=1; i<=n; i++)
        d[i][0]=d[i][1]=INF;
    memset(vis,0,sizeof(vis));
    memset(dp,0,sizeof(dp));
    d[s][0]=0;
    dp[s][0]=1;
    while(1)
    {
        int maxn=INF;
        int v,flag;
        for(int j=1; j<=n; j++)
        {
            if(!vis[j][0]&&maxn>d[j][0])
            {
                maxn=d[j][0];
                v=j;flag=0;
            }
            else if(!vis[j][1]&&maxn>d[j][1])
            {
                maxn=d[j][1];
                v=j;flag=1;
            }
        }
        if(v==e&&flag==1) break;
        if(maxn==INF) break;
        vis[v][flag]=1;
        for(int u=head[v]; u!=-1; u=edge[u].next)
        {
            int j=edge[u].v,w=edge[u].w;
            if(!vis[j][0]&&d[v][flag]+w<d[j][0])
            {
                d[j][1]=d[j][0];
                d[j][0]=d[v][flag]+w;
                dp[j][1]=dp[j][0];
                dp[j][0]=dp[v][flag];
            }
            else if(!vis[j][0]&&d[v][flag]+w==d[j][0])
                dp[j][0]+=dp[v][flag];
            else if(!vis[j][1]&&d[v][flag]+w<d[j][1])
            {
                d[j][1]=d[v][flag]+w;
                dp[j][1]=dp[v][flag];
            }
            else if(!vis[j][1]&&d[v][flag]+w==d[j][1])
                dp[j][1]+=dp[v][flag];
        }
    }
}

int main()
{
    int s,e,T;
    int x,y,w;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d %d",&n,&m);
        init();
        for(int i=0; i<m; i++)
        {
            scanf("%d %d %d",&x,&y,&w);
            addedge(x,y,w);
        }
        scanf("%d %d",&s,&e);
        djstl(s,e);
        if(d[e][0]+1==d[e][1])
        printf("%d\n",dp[e][0]+dp[e][1]);
        else
        printf("%d\n",dp[e][0]);
    }
    return 0;
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值